// xfiles_decryptDlg.cpp : implementation file
//

#include "stdafx.h"
#include "xfiles_decrypt.h"
#include "xfiles_decryptDlg.h"

//#include "dir.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CXfiles_decryptDlg dialog

CXfiles_decryptDlg::CXfiles_decryptDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXfiles_decryptDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXfiles_decryptDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CXfiles_decryptDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXfiles_decryptDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CXfiles_decryptDlg, CDialog)
	//{{AFX_MSG_MAP(CXfiles_decryptDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_MESSAGE(WM_DROPFILES,OnDropFiles)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXfiles_decryptDlg message handlers

BOOL CXfiles_decryptDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	DragAcceptFiles(true);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CXfiles_decryptDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CXfiles_decryptDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//
//
LRESULT CXfiles_decryptDlg::OnDropFiles(WPARAM wParam, LPARAM lParam)
{
  TCHAR lpszFile[MAX_PATH] = {0};
  UINT uFile = 0;
  HDROP hDrop = (HDROP)wParam;
  CEdit* pEdit;

  uFile = DragQueryFile(hDrop, 0xFFFFFFFF, NULL, NULL);
  if (uFile != 1){
 	MessageBox (_T("Dropping multiple files is not supported."),NULL, MB_ICONERROR);
	DragFinish(hDrop);
	return 0 ;
  }
  
  lpszFile[0] = '\0';
  if (DragQueryFile(hDrop, 0, lpszFile, MAX_PATH))
  {
	//MessageBox (lpszFile, NULL, MB_ICONINFORMATION);

	CString s1 = _T(lpszFile);
    CString s2 ;
    s2=s1;
    s1.TrimRight(_T(".xctl"));
    if (s1!=s2) { 
		pEdit = (CEdit*) GetDlgItem(IDC_EDIT1);
	    pEdit->SetWindowText(_T(lpszFile));
    } else { 
		s1.TrimRight(_T(".xmch"));
		if (s1!=s2) { 
		  pEdit = (CEdit*) GetDlgItem(IDC_EDIT1);
	      pEdit->SetWindowText(_T(lpszFile));
		}
	}	  

  }
			
  DragFinish(hDrop);

  return 0;
}

//
//
void CXfiles_decryptDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here

	TCHAR pf[MAX_PATH]; 
    CString str;
    ::GetModuleFileName(NULL, pf, MAX_PATH);
    str = pf;
    str = str.Mid(0,str.ReverseFind('\\')+1);// str   
	
	CFileDialog dlg(TRUE);
    // 
	dlg.m_ofn.lpstrFilter="X-files\0*.xctl;*.xmch\0All files\0*.*\0\0";
    //  
    dlg.m_ofn.lpstrInitialDir= str;
    //   
    dlg.m_ofn.lpstrTitle=" X-Files";
    // 
    if (IDOK==dlg.DoModal()) {
	  CEdit* pEdit;
      pEdit = (CEdit*) GetDlgItem(IDC_EDIT1);
	  pEdit->SetWindowText(_T(dlg.m_ofn.lpstrFile));
	}
	
}

//
//
void CXfiles_decryptDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
  CEdit* pEdit;

  char szFn[1024];
  pEdit = (CEdit*) GetDlgItem(IDC_EDIT1);
  pEdit->GetWindowText(szFn, sizeof(szFn) / sizeof(szFn[0]) - 1);

  int fl = 0;
  CString s1 = _T(szFn);
  CString s2 ;
  s2=s1;
  s1.TrimRight(_T(".xctl"));
  if (s1!=s2) { 
	fl=1;
  } else { 
		s1.TrimRight(_T(".xmch"));
		if (s1!=s2) { 
		  fl=2;
		}
	}	  

  if (fl==0) {
	  AfxMessageBox("   !!! \n   Vericut-a: .xctl  .xmch \n  ",MB_OK,0);
	  return ;
  }
  
  CFileStatus status;
  if(0==CFile::GetStatus( szFn, status ) )
  {
   CString str1 = "File = " ;
   CString str2 = _T(szFn) ;
   CString str3 = _T(" not exists") ;
   AfxMessageBox(str1+str2+str3,MB_OK,0);
   return ;
  }

  // 1
  CFile myFile;
  CFileException fileException;

  if ( !myFile.Open( szFn, CFile::modeWrite, &fileException ) )
  {
    TRACE( "Can't open file %s, error = %u\n",
       szFn, fileException.m_cause );
	return ;
  }

  char      szBuffer[4]="BZh"; 
  myFile.Seek( 0, CFile::begin );
  myFile.Write( szBuffer, 3 );
  myFile.Flush();
  myFile.Close();

  // 2
  s1 = _T(szFn);
  s2=s1;
  s1.TrimRight(_T(".xctl"));
  if (s1==s2) { s1.TrimRight(_T(".xmch")); s1=s1+".mch.bz2"; } else { s1=s1+".ctl.bz2"; }
  
  CFile::Rename(szFn,s1);

  AfxMessageBox(": \n 1.  CGT  BZh \n 2.   .bz2\n  :" + s1,MB_OK,0);

}
